﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace AppointmentCommon
{
    public static class AppointmentGeneration
    {
        public static IEnumerable<AppointmentModel> GenerateRandomAppointments(int duration, DateTime day, TimeSpan startDay, TimeSpan endDay)
        {
            var startOfDay = day.Date.Add(startDay);
            var endOfDay = day.Date.Add(endDay);
            var currentTime = startOfDay;
            var counter = 1;
            var appointments = new List<AppointmentModel>();
            while (currentTime < endOfDay)
            {
                var doubleDuration = Helpers.RandomBool(0.1);
                appointments.Add(new AppointmentModel{
                                                         ID = counter++,
                                                         ApptName = string.Format("{0} {1}", Helpers.RandomName(), Helpers.RandomName()),
                                                         Due = currentTime,
                                                         Duration = new TimeSpan(0, doubleDuration ? 2 * duration : duration, 0),
                                                         Notes = Helpers.RandomBool(0.5)
                                                             ? string.Format("{0}{0}{1}{1}{0}{0}{1}{1}{0}{0}{1}{1}{0}{0}{1}{1} {0}{0}{1}{1}{0}{0}{1}{1}{0}{0}{1}{1}{0}{0}{1}{1}{0}{0}{1}{1}{0}{0}{1}{1}{0}{0}{1}{1}",
                                                                             Helpers.RandomName(),
                                                                             Helpers.RandomName())
                                                             : string.Format("{0} {1} {2}", Helpers.RandomName(), Helpers.RandomName(), Helpers.RandomName())
                                                     });
                currentTime = currentTime.Add(new TimeSpan(0, doubleDuration ? 2 * duration : duration, 0));
            }
            if (currentTime > endOfDay)
            {
                appointments.Last().Duration = new TimeSpan(0, duration, 0);
            }
            return appointments.AsReadOnly();
        }
    }
}
