﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using AppointmentCommon;
using AppointmentCommon.Annotations;

namespace TestAppointmentsComponentOne
{
    public class AppointmentBookViewModel : INotifyPropertyChanged
    {

        private ObservableCollection<TimeSlotViewModel> _daySessionDataList;
        public ObservableCollection<TimeSlotViewModel> DaySessionDataList
        {
            get
            {
                if (_daySessionDataList == null)
                {
                    _daySessionDataList = new ObservableCollection<TimeSlotViewModel>();
                }

                return _daySessionDataList;
            }
        }

        private TimeSlotViewModel _selectedDaySession;
        public TimeSlotViewModel SelectedDaySession
        {
            get { return _selectedDaySession; }
            set
            {
                if (value == _selectedDaySession) return;

                _selectedDaySession = value;
                OnPropertyChanged("SelectedDaySession");
            }
        }

        private bool _multiLine;
        public bool MultiLine
        {
            get { return _multiLine; }
            set
            {
                _multiLine = value;
                OnPropertyChanged("MultiLine");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
